#
# spec file for package cmus
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
# Copyright (c) 2007-2012 Pascal Bleser <pascal.bleser@opensuse.org>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%bcond_without sndio

Name:           cmus
Version:        2.8.0~20190219.ge27e813
Release:        9.1
Summary:        Text-mode music player
License:        GPL-2.0-only
Group:          Productivity/Multimedia/Sound/Players
Url:            https://cmus.github.io/
Source:         %{name}-%{version}.tar.xz
# cmus only builds with gcc >= 4.9
%if 0%{?suse_version} > 1320
BuildRequires:  gcc
%else
%if 0%{?sle_version} == 120200
# Leap 42.2
BuildRequires:  gcc6
%else
# Leap 42.3+ / SLE12SP3Backports
BuildRequires:  gcc7
%endif
%endif
BuildRequires:  git-core
BuildRequires:  libmpcdec-devel
BuildRequires:  pkgconfig
%if %{with sndio}
BuildRequires:  sndio-devel
%endif
BuildRequires:  ncurses-devel
BuildRequires:  update-desktop-files
BuildRequires:  pkgconfig(alsa) >= 1.0.11
BuildRequires:  pkgconfig(ao)
BuildRequires:  pkgconfig(flac)
BuildRequires:  pkgconfig(jack)
BuildRequires:  pkgconfig(libavformat)
BuildRequires:  pkgconfig(libcddb)
BuildRequires:  pkgconfig(libcdio_cdda)
BuildRequires:  pkgconfig(libcue)
BuildRequires:  pkgconfig(libdiscid)
BuildRequires:  pkgconfig(libmikmod)
BuildRequires:  pkgconfig(libmodplug)
BuildRequires:  pkgconfig(libpulse) >= 0.9.19
BuildRequires:  pkgconfig(libsystemd)
# BuildRequires:  pkgconfig(ncurses)
BuildRequires:  pkgconfig(opusfile)
BuildRequires:  pkgconfig(samplerate)
BuildRequires:  pkgconfig(vorbisfile)
BuildRequires:  pkgconfig(wavpack)
Recommends:     %{name}-plugin-cue = %{version}-%{release}
Recommends:     %{name}-plugin-ffmpeg = %{version}-%{release}
# cmus has problems with lavf and 24-bit audio
Recommends:     %{name}-plugin-flac = %{version}-%{release}
# these are not provided by tumbleweed ffmpeg yet
Recommends:     %{name}-plugin-mpc = %{version}-%{release}
Recommends:     %{name}-plugin-pulse = %{version}-%{release}
Recommends:     %{name}-plugin-wavpack = %{version}-%{release}

%description
C* Music Player is a small and fast text mode (ncurses-based) music player
for Unix-like operating systems.

%package plugin-libao
Summary:        Libao output plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-libao
This package provides libao output support for the C* Music Player.

%package plugin-jack
Summary:        JACK output plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-jack
This package provides JACK output support for the C* Music Player.

%package plugin-pulse
Summary:        Pulseaudio output plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-pulse
This package provides PulseAudio output support for the C* Music Player.

%if %{with sndio}
%package plugin-sndio
Summary:        Sndio output plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-sndio
This package provides sndio output support for the C* Music Player.
%endif

%package plugin-cdio
Summary:        CDIO plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-cdio
This package provides CDIO support for the C* Music Player.

%package plugin-cue
Summary:        CUE input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-cue
This package provides CUE sheet support for the C* Music Player.

%package plugin-ffmpeg
Summary:        FFmpeg input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}
Obsoletes:      %{name}-plugin-aac
Obsoletes:      %{name}-plugin-mad

%description plugin-ffmpeg
This package provides FFmpeg input support for the C* Music Player.

%package plugin-flac
Summary:        FLAC input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-flac
This package provides FLAC input support for the C* Music Player.

%package plugin-vorbis
Summary:        Vorbis input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-vorbis
This package provides Vorbis input support for the C* Music Player.

%package plugin-mikmod
Summary:        MikMod input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-mikmod
This package provides MikMod (tracker) input support for the C* Music Player.

%package plugin-modplug
Summary:        Modplug input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-modplug
This package provides modplug (tracker) input support for the C* Music Player.

%package plugin-mpc
Summary:        MPC (Musepack) input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-mpc
This package provides MPC (Musepack) input support for the C* Music Player.

%package plugin-opus
Summary:        Opus input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-opus
This package provides Opus input support for the C* Music Player.

%package plugin-wavpack
Summary:        WavPack input plugin for the C* Music Player
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}

%description plugin-wavpack
This package provides WavPack input support for the C* Music Player.

%package plugins-all
Summary:        Installs all %{name} plugins
Group:          Productivity/Multimedia/Sound/Players
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-plugin-cdio = %{version}-%{release}
Requires:       %{name}-plugin-cue = %{version}-%{release}
Requires:       %{name}-plugin-ffmpeg = %{version}-%{release}
Requires:       %{name}-plugin-flac = %{version}-%{release}
Requires:       %{name}-plugin-jack = %{version}-%{release}
Requires:       %{name}-plugin-libao = %{version}-%{release}
Requires:       %{name}-plugin-mikmod = %{version}-%{release}
Requires:       %{name}-plugin-modplug = %{version}-%{release}
Requires:       %{name}-plugin-mpc = %{version}-%{release}
Requires:       %{name}-plugin-opus = %{version}-%{release}
Requires:       %{name}-plugin-pulse = %{version}-%{release}
%if %{with sndio}
Requires:       %{name}-plugin-sndio = %{version}-%{release}
%endif
Requires:       %{name}-plugin-vorbis = %{version}-%{release}
Requires:       %{name}-plugin-wavpack = %{version}-%{release}

%description plugins-all
This package pulls in all the plugins for the C* Music Player.

%prep
%setup -q

%build
# not autoconf
export CC=gcc
test -x "$(type -p gcc-5)" && export CC=gcc-5
test -x "$(type -p gcc-6)" && export CC=gcc-6
test -x "$(type -p gcc-7)" && export CC=gcc-7
./configure \
    prefix="%{_prefix}" \
    bindir="%{_bindir}" \
    datadir="%{_datadir}" \
    libdir="%{_libdir}" \
    mandir="%{_mandir}" \
    exampledir="%{_docdir}/%{name}.xxx/examples" \
%if %{with sndio}
    CONFIG_SNDIO=y \
%endif
    CONFIG_{ALSA,AO,CDDB,CDIO,CUE,DISCID,FFMPEG,FLAC,JACK,MIKMOD,MODPLUG,MPC,MPRIS,OPUS,OSS,PULSE,SAMPLERATE,VORBIS,WAVPACK,WAV}=y \
    CONFIG_{AAC,ARTS,COREAUDIO,MAD,BASS,MP4,ROAR,SUN,TREMOR,VTX,WAVEOUT}=n \
    USE_FALLBACK_IP=y \
    CFLAGS="%{optflags}"

make %{?_smp_mflags} V=1 CC=${CC}

%install
%make_install
rm -rfv "%{buildroot}%{_docdir}/%{name}.xxx"
chmod 0644 cmus-status-display

cat<<EOF >README.plugins-all
This subpackage is empty but requires all the available %{name} plugin packages
EOF

%files
%defattr(-,root,root)
%doc AUTHORS COPYING README.md
%doc cmus-status-display
%doc data/rc
%{_bindir}/cmus
%{_bindir}/cmus-remote
%dir %{_libdir}/cmus
%dir %{_libdir}/cmus/ip
%{_libdir}/cmus/ip/wav.so
%dir %{_libdir}/cmus/op
%{_libdir}/cmus/op/alsa.so
%{_libdir}/cmus/op/oss.so
%dir %{_datadir}/cmus
%{_datadir}/cmus/*.theme
%config(noreplace) %{_datadir}/cmus/rc
%{_mandir}/man1/cmus*.1%{ext_man}
%{_mandir}/man7/cmus-tutorial.7%{ext_man}

%files plugin-libao
%defattr(-,root,root)
%{_libdir}/cmus/op/ao.so

%files plugin-jack
%defattr(-,root,root)
%{_libdir}/cmus/op/jack.so

%files plugin-pulse
%defattr(-,root,root)
%{_libdir}/cmus/op/pulse.so

%if %{with sndio}
%files plugin-sndio
%defattr(-,root,root)
%{_libdir}/cmus/op/sndio.so
%endif

%files plugin-cdio
%defattr(-,root,root)
%{_libdir}/cmus/ip/cdio.so

%files plugin-cue
%defattr(-,root,root)
%{_libdir}/cmus/ip/cue.so

%files plugin-flac
%defattr(-,root,root)
%{_libdir}/cmus/ip/flac.so

%files plugin-vorbis
%defattr(-,root,root)
%{_libdir}/cmus/ip/vorbis.so

%files plugin-ffmpeg
%defattr(-,root,root)
%{_libdir}/cmus/ip/ffmpeg.so

%files plugin-mikmod
%defattr(-,root,root)
%{_libdir}/cmus/ip/mikmod.so

%files plugin-modplug
%defattr(-,root,root)
%{_libdir}/cmus/ip/modplug.so

%files plugin-mpc
%defattr(-,root,root)
%{_libdir}/cmus/ip/mpc.so

%files plugin-opus
%defattr(-,root,root)
%{_libdir}/cmus/ip/opus.so

%files plugin-wavpack
%defattr(-,root,root)
%{_libdir}/cmus/ip/wavpack.so

%files plugins-all
%defattr(-,root,root)
%doc README.plugins-all

%changelog
* Sat Feb 23 2019 9@cirno.systems
- Update to version 2.8.0~20190219.ge27e813:
  * Ensures all data sent on dbus is in utf8 (#847) (#871)
  * bits-per-sample fixes (#870)
  * Fixes incorect bit rate declaration for 24bit flac (#867)
  * Changes yes_no_query to signal error on cmus exit (#858)
  * Add support for elogind (#846)
  * ip/ffmpeg: enable opus support (#865)
  * Add note about overriding keybindings using rc (closes #742) (#866)
  * Avoid -I$(pwd) (#820)
  * Fixes ffmpeg deprecations (#861)
  * Add *.lo to clean in Makefile (#864)
  * Fixes various compiler warning (#862)
  * added "exiting" player status (#648)
  * Makes save -p consistent with documentation (#859)
  * Make cmus-update*.py use env python and fix pidgin with py3 (#857)
  * cmus 2.8.0
  * README: note that cmus is not actively maintained
  * Fix CI build by specifying gcc version for Linux. Add OSX to CI test (#854)
  * Increasing print buffer to fix crashes on ultra wide screens (#853)
* Wed Dec  5 2018 9@cirno.systems
- Update to version 2.8.0~20181120.gf5a442a:
  * Change to get_non_empty_env for CMUS_PLAYLIST_DIR. (#836)
  * Add support for CMUS_PLAYLIST_DIR. (#830)
  * Add documentation for passwd option (#824)
  * Accept PARTOFACOMPILATION tag (#807)
* Wed May 30 2018 9@cirno.systems
- Update to version 2.8.0~20180524.g8cccf70:
  * Skip track when seeking past track duration (#803)
* Sun Apr 22 2018 9@cirno.systems
- Update to version 2.8.0~20180422.gb595b8c:
  * Fix ffmpeg plugin build (#793)
  * Correct parsing for cue files with byte order mark (#774)
  * Add dracula theme
  * Add albumartist to status_display_program.
  * options: add color_win_cur_attr
  * Add command to raise VTE window + implement MPRIS Raise method
  * Don't call mpris_seeked from within the player
  * Make player_set_op accept an owned string
  * Add the delegate series of functions
  * Make most player functions delegated
* Wed Jan 31 2018 olaf@aepfle.de
- Adjust usage of gccN for Leap42 and SLE12
* Wed Nov  1 2017 9@cirno.systems
- Update to version 2.8.0~20171019.g3a4ce9c:
  * Add version command (#733)
  * handle "REM COMPILATION TRUE" in cue generated by XLD
  * Make ^U/^D default for half-page up/down motions
  * Remove double-inclusion of stdatomic header
* Mon Jul 10 2017 olaf@aepfle.de
- Use the detected gccN
- Add bcond for sndio
* Sun Jul  2 2017 9@cirno.systems
- Update to version 2.8.0~20170702.g61d4b2b:
  * Fixed `status_display_program` being called only once when
    "repeat current" is set
* Thu Jun 29 2017 olaf@aepfle.de
- Adjust usage of gccN for Leap42 and SLE12
* Wed Jun 21 2017 9@cirno.systems
- Update to version 2.8.0~20170505.g0da3472:
  * Fixed Linux kernel style link
  * Enable tilde expansion for :player-play
  * Make flac do sample rate accurrate seek
  * fix cue rounding to make it sample rate accurate
  * Expose stream info via MPRIS
  * added D-Bus (MPRIS) section to man page
  * Add some trailing commas
  * made album color in trackwin configurable
  * Fix MPRIS CanGoPrevious property typo
* Fri Feb 24 2017 olaf@aepfle.de
- Remove mp4 plugin
* Mon Sep 21 2015 olaf@aepfle.de
- Update to version 2.7.1
* Mon Sep 21 2015 olaf@aepfle.de
- Convert to BuildRequires pkgconfig, enable libcue,opus,roar support
* Tue Feb 10 2015 avvissu@yandex.ru
- add cdio plugin
* Wed Nov  5 2014 p.seiler@linuxmail.org
- update to version 2.6.0:
  Major new features:
  * show all tracks when artist is selected in the tree view
  * JACK output plugin
  * Opus input plugin
  Other notable new things:
  * «Night» and «Solarized» color schemes
  * reverse sort order support
  * ReplayGain closer to the spec
  * vim-style <c-e> / <c-y> scrolling
  * follow option
  * show_playback_position option
  * XDG directories support
  * better support for newer versions of FFmpeg
  * support for .oga and .ogx file extensions
  * stream metadata in cmus-remote -Q
* Thu Jun 12 2014 p.seiler@linuxmail.org
- Build against ffmpeg(2) not ffmpeg1
- updated package to 2.5.1:
  * CUE sheets support. When adding e.g. `track.flac` to the library, cmus will
  check for `track.cue` or `track.flac.cue` in the same directory. If it founds
  one, it will ignore the tags in `track.flac` and use CUE metadata instead
  * cdio input plugin, for those of you who still remember what a CD is :-)
  * support for WavPack `.wvc` correction files
  * new «zenburn» color scheme (as seen at http://cmus.sf.net/), and text
  attributes (bold/reverse/…) support for UI elements
  * improved tab completion, new `scroll_offset` and `icecast_default_charset`
  options, even better tag parsing and compilations handling, and numerous small
  enhancements all over the place.
* Tue Jan 28 2014 guillaume@opensuse.org
- Build against ffmpeg1 not ffmpeg(2)
* Thu Nov  8 2012 pascal.bleser@opensuse.org
- update to 2.5.0:
  * adds CUE sheet support
  * adds cdio input plugin
  * adds support for WavPack correction files
  * adds a new "zenburn" color scheme
  * improvements to tab completion, tag parsing, and compilation handling
* Wed Nov 30 2011 pascal.bleser@opensuse.org
- update to 2.4.3:
  * maintenance release: it mostly fixes several build and stability issues
    caused by external library changes
* Sun Jul 24 2011 pascal.bleser@opensuse.org
- update to 2.4.2:
  * several important bug and build fixes; everyone is encouraged to upgrade
* Thu May 26 2011 pascal.bleser@opensuse.org
- update to 2.4.1:
  * fixes crashes and misbehaviours
* Sun Apr 24 2011 detlef@links2linux.de
- update to 2.4.0:
  * this release features tons of improvements, with most notable ones being
    live library/playlist filtering and playback resume support
* Sun Apr 10 2011 pascal.bleser@opensuse.org
- update to 2.3.5:
  * several serious (but rarely encountered) issues have been fixed
- build with optflags
* Thu Feb 10 2011 pascal.bleser@opensuse.org
- update to 2.3.4:
  * features an ability to restore the playback volume after restart (when
    using PulseAudio output plugin)
  * adds APE files support (using the FFMPEG input plugin)
  * bugfixes
* Thu Jun 17 2010 pascal@links2linux.de
- update to 2.3.3:
  * a couple of serious bugs has been fixed, so everybody is encouraged to
    upgrade
  * support for the newest version of mp4v2 was added
* Thu Apr 15 2010 pascal@links2linux.de
- update to 2.3.2:
  * libao 1.0 compatibility issue are fixed
* Sun Mar 14 2010 pascal.bleser@opensuse.org
- update to 2.3.1:
  * ID3 parsing was fixed
  * a minor documentation update was done
  * MP3s with broken CRC are now supported
  * a default binding was set for "q"
  * insecure /tmp usage was fixed
* Tue Mar  2 2010 pascal.bleser@opensuse.org
- update to 2.3.0
* Sat Jul 28 2007 guru@unixtech.be
- new package
